package com.ruoyi.common.utils;

public final class DeptUtils
{
    public static final int LEVEL_INVALID = 0; // 无效
    public static final int LEVEL_PROVINCE = 1; // 省
    public static final int LEVEL_CITY = 2; // 市
    public static final int LEVEL_COUNTY = 3; // 区
    public static final int LEVEL_TOWN = 4; // 镇
    public static final int LEVEL_VILLAGE = 5; // 村
    public static final int LEVEL_GROUP = 6; // 组

    public static String[] parseOrgCode(String orgCode)
    {
        String[] res = new String[7]; // 0-6(0无效), 1省, 2市, 3区, 4镇, 5村, 6组

        res[0] = levelStr(LEVEL_INVALID);
        if(StringUtils.isEmpty(orgCode))
            return res;

        int length = orgCode.length();
        if(length >= 2)
        {
            res[1] = orgCode.substring(0, 2);
            res[0] = levelStr(LEVEL_PROVINCE);
        }
        if(length >= 4)
        {
            res[2] = orgCode.substring(2, 2);
            res[0] = levelStr(LEVEL_CITY);
        }
        if(length >= 6)
        {
            res[3] = orgCode.substring(4, 6);
            res[0] = levelStr(LEVEL_COUNTY);
        }
        if(length >= 9)
        {
            res[4] = orgCode.substring(6, 9);
            res[0] = levelStr(LEVEL_TOWN);
        }
        if(length >= 12)
        {
            res[5] = orgCode.substring(9, 12);
            res[0] = levelStr(LEVEL_VILLAGE);
        }
        if(length >= 16)
        {
            res[6] = orgCode.substring(12, 16);
            res[0] = levelStr(LEVEL_GROUP);
        }

        return res;
    }

    public static String[] parseFullOrgCode(String orgCode)
    {
        String[] res = new String[7]; // 0-6(0无效), 1省, 2市, 3区, 4镇, 5村, 6组

        res[0] = levelStr(LEVEL_INVALID);
        if(StringUtils.isEmpty(orgCode))
            return res;

        int length = orgCode.length();
        if(length >= 2)
        {
            res[1] = orgCode.substring(0, 2);
            res[0] = levelStr(LEVEL_PROVINCE);
        }
        if(length >= 4)
        {
            res[2] = orgCode.substring(0, 2);
            res[0] = levelStr(LEVEL_CITY);
        }
        if(length >= 6)
        {
            res[3] = orgCode.substring(0, 6);
            res[0] = levelStr(LEVEL_COUNTY);
        }
        if(length >= 9)
        {
            res[4] = orgCode.substring(0, 9);
            res[0] = levelStr(LEVEL_TOWN);
        }
        if(length >= 12)
        {
            res[5] = orgCode.substring(0, 12);
            res[0] = levelStr(LEVEL_VILLAGE);
        }
        if(length >= 16)
        {
            res[6] = orgCode.substring(0, 16);
            res[0] = levelStr(LEVEL_GROUP);
        }

        return res;
    }

    public static int parseOrgCodeLevel(String orgCode)
    {
        return StringUtils.isEmpty(orgCode) ? LEVEL_INVALID : parseOrgCodeLevel(orgCode.length());
    }


    public static int parseOrgCodeLevel(int length)
    {
        int res = LEVEL_INVALID;

        if(length >= 16)
        {
            res = LEVEL_GROUP;
        }
        else if(length >= 12)
        {
            res = LEVEL_VILLAGE;
        }
        else if(length >= 9)
        {
            res = LEVEL_TOWN;
        }
        else if(length >= 6)
        {
            res = LEVEL_COUNTY;
        }
        else if(length >= 4)
        {
            res = LEVEL_CITY;
        }
        else if(length >= 2)
        {
            res = LEVEL_PROVINCE;
        }

        return res;
    }

    public static String levelStr(int level)
    {
        return "" + level;
    }

    public static int levelInt(String level)
    {
        return null == level ? LEVEL_INVALID : Integer.parseInt(level);
    }

    private DeptUtils() {}
}
